Unit AFG7R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFG7R(NM :Integer; N :Integer; LOW :Integer; IGH :Integer;
                var A :Array of Real; var ORT :Array of Real);

implementation

procedure AFG7R(NM :Integer; N :Integer; LOW :Integer; IGH :Integer;
                var A :Array of Real; var ORT :Array of Real);
var
I,II,J,JJ,KP1,LA,M,MP :Integer;
F,G,H,SCALE :Real;
const
SYS056 :Real = 1.175495E-38;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120;
begin
{      SYS056 = SYS055 }
LA := IGH - 1;
KP1 := LOW + 1;
if ( LA <  KP1 ) 
 then goto _120;
for M:=KP1 to LA do
 begin
  H := 0.0;
  ORT[M-1] := 0.0;
  SCALE := 0.0;
{  HOPMPOBKA CTOA }
  for I:=M to IGH do
   begin
    SCALE := SCALE + Abs(A[(I-1)+(M-2)*NM]);
_10:
   end;
{      IF(SCALE.EQ..) GO TO 18 }
  if ( SCALE >  SYS056 ) 
   then goto _30;
  for I:=M to IGH do
   begin
    A[(I-1)+(M-2)*NM] := 0.0;
_20:
   end;
  goto _110;
_30:
  MP := M + IGH;
  F := 1.0/SCALE;
{  I = IGH,M,-1 }
  for II:=M to IGH do
   begin
    I := MP - II;
    ORT[I-1] := A[(I-1)+(M-2)*NM]*F;
    H := H + ORT[I-1]*ORT[I-1];
_40:
   end;
  G := -Sign(Sqrt(H),ORT[M-1]);
  H := H - ORT[M-1]*G;
  ORT[M-1] := ORT[M-1] - G;
{  OPM-E MATP (I-(U*UT)/H)*A }
  for J:=M to N do
   begin
    F := 0.0;
{  I = IGH,M,-1 }
    for II:=M to IGH do
     begin
      I := MP - II;
      F := F + ORT[I-1]*A[(I-1)+(J-1)*NM];
_50:
     end;
    F := F/H;
    for I:=M to IGH do
     begin
      A[(I-1)+(J-1)*NM] := A[(I-1)+(J-1)*NM] - F*ORT[I-1];
_60:
     end;
_70:
   end;
{  OPM-E MATP (I-(U*UT)/H)*A*(I-(U*UT)/H) }
  for I:=1 to IGH do
   begin
    F := 0.0;
{  J = IGH,M,-1 }
    for JJ:=M to IGH do
     begin
      J := MP - JJ;
      F := F + ORT[J-1]*A[(I-1)+(J-1)*NM];
_80:
     end;
    F := F/H;
    for J:=M to IGH do
     begin
      A[(I-1)+(J-1)*NM] := A[(I-1)+(J-1)*NM] - F*ORT[J-1];
_90:
     end;
_100:
   end;
  ORT[M-1] := SCALE*ORT[M-1];
  A[(M-1)+(M-2)*NM] := SCALE*G;
_110:
 end;
_120:
end;

end.
